export function validateImportStatement(statement) {
    if (typeof statement !== "object")
        return undefined;
    if (typeof statement.module !== "string")
        return undefined;
    if (typeof statement.name !== "string")
        return undefined;
    if (statement.as && typeof statement.as !== "string")
        return undefined;
    if (!["default", "named"].includes(statement.type))
        return undefined;
    if (statement.isType && typeof statement.isType !== "boolean")
        return undefined;
    return {
        module: statement.module,
        name: statement.name,
        as: statement.as ?? undefined,
        type: statement.type,
        isType: statement.isType ?? undefined,
    };
}
//# sourceMappingURL=ImportStatement.js.map